/*****************************************************************************
 *  File: app_selector.c
 *
 *  This file contains functions for performing general tasks associated
 *  with the application selector.
 *
 ****************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <sys/alt_alarm.h>
#include <string.h>
#include "includes.h"
#include "os_utils.h"
#include "webserver.h"
#include "sys/alt_cache.h"
#include "sys/alt_flash.h"
#include "sys/alt_flash_dev.h"
#include "system.h"
#include "alt_types.h"
#include "io.h"
#include "reconfig_utils.h"
#include "altera_avalon_pio_regs.h"
#include "srec/srec.h"

// Flash semaphore
extern OS_EVENT *FlashSem;


/*****************************************************************************
 *  Function: ReconfigFPGA16DIRECT
 *
 *  Purpose: Uses the alt_remote_update megafunction to recongigure the FPGA
 *           from the byte-offset in flash, "hw_flash_offset"
 *
 *  Returns: 0 ( but never exits since it reconfigures the FPGA )
 *
 * note:ReconfigFPGA(hw_flash_page = 1); gets called by webserver to reconfigure
 *
 ****************************************************************************/
int ReconfigFPGA(unsigned int hw_flash_page)
{
#ifdef DEBUG_MODE
    printf("DEBUG: Initializiing PFL Option Bits: InitializePFLOptionBits() \n");
    // which i don't believe to be the problem,
    // I think we are somehow screwing up the flash file when programming it
#endif

    // should never get here.
    while (1);

    return ( 0);
}
